'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _React$PropTypes = _react2.default.PropTypes,
    node = _React$PropTypes.node,
    oneOfType = _React$PropTypes.oneOfType,
    string = _React$PropTypes.string,
    array = _React$PropTypes.array;

var Img = function (_Component) {
  (0, _inherits3.default)(Img, _Component);

  function Img() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Img);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Img.__proto__ || (0, _getPrototypeOf2.default)(Img)).call.apply(_ref, [this].concat(args))), _this), _this.state = { currentIndex: 0, isLoading: true, isLoaded: false }, _this.sourceList = [], _this.onLoad = function () {
      return _this.setState({ isLoaded: true });
    }, _this.onError = function () {
      // currentIndex is zero bases, length is 1 based. If no image is found, this
      // will prevent a "broken" placeholder from showing by setting src=""
      // or removing the src prop completely
      if (_this.state.currentIndex < _this.sourceList.length) {
        _this.setState({ currentIndex: ++_this.state.currentIndex });
      } else {
        _this.setState({ isLoading: false });
      }
    }, _this.placeholder = function () {
      if (!_this.state.isLoaded) {
        return _this.state.isLoading ? _this.props.loader : _this.props.unloader;
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Img, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.sourceList = typeof this.props.src === 'string' ? [this.props.src] : this.props.src;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          src = _props.src,
          loader = _props.loader,
          unloader = _props.unloader,
          rest = (0, _objectWithoutProperties3.default)(_props, ['src', 'loader', 'unloader']); //eslint-disable-line

      src = this.sourceList[this.state.currentIndex];

      return _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement('img', (0, _extends3.default)({
          src: src,
          onError: this.onError,
          onLoad: this.onLoad
        }, rest)),
        this.placeholder()
      );
    }
  }]);
  return Img;
}(_react.Component);

Img.defaultProps = {
  loader: false,
  unloader: false,
  src: []
};
process.env.NODE_ENV !== "production" ? Img.propTypes = {
  loader: node,
  unloader: node,
  src: oneOfType([string, array])
} : void 0;
exports.default = Img;